import org.robovm.apple.coregraphics.CGRect;
import org.robovm.apple.foundation.NSAutoreleasePool;
import org.robovm.apple.foundation.NSDictionary;
import org.robovm.apple.foundation.NSString;
import org.robovm.apple.uikit.NSLayoutAttribute;
import org.robovm.apple.uikit.NSLayoutConstraint;
import org.robovm.apple.uikit.NSLayoutRelation;
import org.robovm.apple.uikit.UIApplication;
import org.robovm.apple.uikit.UIApplicationDelegateAdapter;
import org.robovm.apple.uikit.UIColor;
import org.robovm.apple.uikit.UIScreen;
import org.robovm.apple.uikit.UIView;
import org.robovm.apple.uikit.UIViewController;
import org.robovm.apple.uikit.UIWindow;

public class IOSHelloWorld extends UIApplicationDelegateAdapter {
    
    public static class MyView extends UIView {
        public MyView() {
            super(new CGRect(0f,0f,0f,0f));

            setTranslatesAutoresizingMaskIntoConstraints(false);
            setBackgroundColor(UIColor.colorWhite());

            UIView subView = new UIView(new CGRect(0f,0f,0f,0f));
            subView.setTranslatesAutoresizingMaskIntoConstraints(false);
            subView.setBackgroundColor(UIColor.colorGreen());

            addSubview(subView);

            addConstraint(NSLayoutConstraint.create(subView,
                    NSLayoutAttribute.Width, NSLayoutRelation.Equal, this,
                    NSLayoutAttribute.Width, 0.5f, 0f));
            addConstraint(NSLayoutConstraint.create(subView,
                    NSLayoutAttribute.Height, NSLayoutRelation.Equal, this,
                    NSLayoutAttribute.Height, 0.5f, 0f));
            addConstraint(NSLayoutConstraint.create(subView,
                    NSLayoutAttribute.CenterY, NSLayoutRelation.Equal, this,
                    NSLayoutAttribute.CenterY, 1f, 0f));
            addConstraint(NSLayoutConstraint.create(subView,
                    NSLayoutAttribute.CenterX, NSLayoutRelation.Equal, this,
                    NSLayoutAttribute.CenterX, 1f, 0f));
        }
    }
    
    public static class MyController extends UIViewController {
        @Override
        public void loadView() {
            setView(new MyView());
        }
    }
    
    @Override
    public boolean didFinishLaunching(UIApplication application,
            NSDictionary<NSString, ?> launchOptions) {
        
        UIWindow window = new UIWindow(UIScreen.getMainScreen().getBounds());
        window.setBackgroundColor(UIColor.colorWhite());
        MyController myController = new MyController();
        window.setRootViewController(myController);
        window.makeKeyAndVisible();
        
        // Prevent the UIWindow and MyController Java instances from being GCed
        // until the UIApplication ObjC object instance is deallocated
        application.addStrongRef(myController);
        application.addStrongRef(window);
        
        return true;
    }

    public static void main(String[] args) {
        try (NSAutoreleasePool pool = new NSAutoreleasePool()) {
            UIApplication.main(args, null, IOSHelloWorld.class);
        }
    }

}
